﻿Type=Activity
Version=3.8
B4A=true
@EndOfDesignText@
#Region Module Attributes
	
#End Region

'Activity module
Sub Process_Globals
	'This map maps between PhoneSensors and SensorData objects.
	Dim SensorsMap As Map
	Type SensorData (Name As String, ThreeValues As Boolean)
	Dim SensorName, SensorValue As List
	Dim Timer1 As Timer
	Dim SensorListSize As Int
End Sub

Sub Globals
	'This map maps between PhoneSensors and Labels.
	Dim SensorsLabels As Map
	
End Sub

Sub Activity_Create(FirstTime As Boolean)
	If FirstTime Then
		Timer1.Initialize("Timer1", 1000)
		SensorsMap.Initialize
		SensorName.Initialize
		SensorValue.Initialize
		
		ProgressDialogShow("Searching sensors ...")
		Dim ps As PhoneSensors 'This object is only used to access the type constants.
		AddSensor(ps.TYPE_ACCELEROMETER, "ACCELEROMETER", True)
		AddSensor(ps.TYPE_GYROSCOPE, "GYROSCOPE", True)
		AddSensor(ps.TYPE_LIGHT, "LIGHT", False)
		AddSensor(ps.TYPE_MAGNETIC_FIELD, "MAGNETIC", True)
		AddSensor(ps.TYPE_ORIENTATION, "ORIENTATION", True)
		AddSensor(ps.TYPE_PRESSURE, "PRESSURE", False)
		AddSensor(ps.TYPE_PROXIMITY, "PROXIMITY", False)
		AddSensor(ps.TYPE_TEMPERATURE, "TEMPERATURE", False)
	End If
	SensorsLabels.Initialize 'SensorsLabels is not a Process_Globals object so we need to create it each time
	For i = 0 To SensorsMap.Size - 1
		Dim ps As PhoneSensors
		ps = SensorsMap.GetKeyAt(i)
		Dim lbl As Label
		lbl.Initialize("")
		lbl.TextColor = Colors.White 
		'Activity.AddView(lbl, 10dip, 10dip + 50dip * i, 100%x - 10dip, 45dip)
		
		SensorsLabels.Put(ps, lbl)
	Next
	
	Timer1.Enabled=True
End Sub

Sub AddSensor(SensorType As Int, Name As String, ThreeValues As Boolean) As SensorData
	Dim sd As SensorData
	sd.Initialize
	sd.Name = Name
	sd.ThreeValues = ThreeValues
	Dim ps As PhoneSensors
	ps.Initialize(SensorType)
	SensorsMap.Put(ps, sd)
	'Log(Name & " MaxValue = " & ps.MaxValue)
End Sub

Sub Activity_Resume
	'Here we start listening for SensorChanged events.
	'By checking the return value we knoe if the sensor is supported.
	For i = 0 To SensorsMap.Size - 1
		Dim ps As PhoneSensors
		Dim sd As SensorData
		Dim lbl As Label
		ps = SensorsMap.GetKeyAt(i)
		sd = SensorsMap.GetValueAt(i)
		lbl = SensorsLabels.Get(ps)
		If ps.StartListening("Sensor") = False Then
						'sd.name removed
			lbl.Text = " is not supported."
			'Log(sd.Name & " is not supported.")
		End If
	Next
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	
	
End Sub

Sub Timer1_Tick
	'Stop listening for events.
	SensorName.Clear
	SensorValue.Clear
	
	For i = 0 To SensorsMap.Size - 1
		Dim ps As PhoneSensors
		Dim sd As SensorData
		Dim lbl As Label
		
		ps = SensorsMap.GetKeyAt(i)
		ps.StopListening
		sd = SensorsMap.Get(ps) 'Get the associated SensorData obejct
		lbl = SensorsLabels.Get(ps) 'Get the associated Label.
		
		SensorName.Add(sd.Name)
		SensorValue.Add(lbl.Text)
	Next

	
	'Log(SensorList)
	
	Timer1.Enabled=False
	ProgressDialogHide
	
	SensorListSize=SensorName.Size-1
	Activity.Finish


End Sub

Sub Sensor_SensorChanged (Values() As Float)
	Dim ps As PhoneSensors
	Dim sd As SensorData
	Dim lbl As Label
	'Get the PhoneSensors object that raised this event.
	ps = Sender
	sd = SensorsMap.Get(ps) 'Get the associated SensorData obejct
	lbl = SensorsLabels.Get(ps) 'Get the associated Label.
	If sd.ThreeValues Then
					'sd.name removed
		lbl.Text = " X=" & NumberFormat(Values(0), 0, 3) & ", Y=" & NumberFormat(Values(1), 0, 3) _ 
			& ", Z=" & NumberFormat(Values(2), 0, 3)
	Else
		lbl.Text =" = " & NumberFormat(Values(0), 0, 3)
	End If
	
End Sub

